;   10  (600 )
; 32'768 
	.INCLUDE "tn25def.inc"

.equ	Fo=3276834*6	; 32768,34*600 
;.equ	Fo=3276800*6	; 32768*600 
.equ	N=Fo/128

.CSEG
.ORG 0x0000
RESET:
	RJMP	START
;***********************************
.ORG 0x000A
T0_COMP_A:
COUNT_599:
	SUBI	R26,BYTE1(1)
	SBCI	R25,BYTE2(1)
	SBCI	R24,BYTE3(1)
	BRNE	COUNT_600
	SBI	PORTB,2
COUNT_600:
	SUBI	R22,BYTE1(1)
	SBCI	R21,BYTE2(1)
	SBCI	R20,BYTE2(1)
	BRMI	MINUTE_10
	BRNE	NO_MINUTE
	OUT	OCR0A,R27
NO_MINUTE:
	RETI
MINUTE_10:
	CBI	PORTB,2
	RET
;***********************************
;***********************************
;***********************************
START:
	SER	R16
	OUT	DDRB,R16

	LDI	R16,1<<PRADC|1<<PRTIM1|1<<PRUSI
	OUT	PRR,R16			;   ADC

	SBI	ACSR,ACD
;********
GO_RAB:
	LDI	R20,BYTE3(Fo/128-1)
	LDI	R21,BYTE2(Fo/128-1)
	LDI	R22,BYTE1(Fo/128-1)	; 600,0    128 

	LDI	R24,BYTE3(Fo/128-Fo/600/10/128)
	LDI	R25,BYTE2(Fo/128-Fo/600/10/128)
	LDI	R26,BYTE1(Fo/128-Fo/600/10/128)	; 599,9 
GO_GND:
	LDI	R27,LOW(Fo-Fo/N*(N-1)-1)

	LDI	R16,128-1
	OUT	OCR0A,R16

	LDI	R16,1<<SE		;  SLEEP IDLE
	OUT	MCUCR,R16

	LDI	R16,1<<OCIE0A
	OUT	TIMSK,R16
	OUT	TIFR,R16

	LDI	R16,1<<WGM01
	OUT	TCCR0A,R16				;  CTC
	LDI	R16,0<<WGM02|1<<CS00
	OUT	TCCR0B,R16				;  CTC F/1

	SEI
;********************
WAIT_10MIN:
	SLEEP
	BRIE	WAIT_10MIN

	RJMP	START
.EXIT
